import junit.framework.*;
import junit.swingui.TestRunner;

public class TestAddress extends TestCase {
  public static void main(String[] args) {
    TestRunner.main(new String[]{"TestAddress"});
  }

  public TestAddress(String name) {
    super(name);
  }

  private Address a;

  public void setUp() throws Exception {
    a = new Address();
  }

  public void tearDown() throws Exception {
  }

  public void testEmptyAddress() throws Exception {
    assertEquals(0, a.lines());
  }

  public void testOneLine() throws Exception {
    a.addLine("line1");
    assertEquals(1, a.lines());
    assertEquals("line1", a.getLine(0));
  }

  public void testTwoLines() throws Exception {
    a.addLine("line1");
    a.addLine("line2");
    assertEquals(2, a.lines());
    assertEquals("line1", a.getLine(0));
    assertEquals("line2", a.getLine(1));
  }
  public void testChangeLine() throws Exception {
    a.addLine("line1");
    a.setLine(0, "newLine1");
    assertEquals("newLine1", a.getLine(0));
  }

  public void testSetEmptyElement() throws Exception {
    a.setLine(0, "newLine1");
    assertEquals(1, a.lines());
    assertEquals("newLine1", a.getLine(0));
  }

  public void testClone() throws Exception {
    a.addLine("line1");
    a.addLine("line2");
    Address a2 = (Address)a.clone();
    a2.setLine(0, "newLine1");
    a2.addLine("line3");
    assertEquals(2, a.lines());
    assertEquals(3, a2.lines());
    assertEquals(a.getLine(0), "line1");
    assertEquals(a.getLine(1), "line2");

    assertEquals(a2.getLine(0), "newLine1");
    assertEquals(a2.getLine(1), "line2");
    assertEquals(a2.getLine(2), "line3");

  }
}
