
import junit.framework.TestCase;
import junit.swingui.TestRunner;

public class TestTreeMap extends TestCase {
  public static void main(String[] args) {
    TestRunner.main(new String[]{"TestTreeMap"});
  }

  public TestTreeMap(String name) {
    super(name);
  }

  private TreeMap sorter;

  public void setUp() throws Exception {
    sorter = new TreeMap();
  }

  public void tearDown() throws Exception {
  }

  public void testSingleName() throws Exception {
    sorter.add("Key", "Value");
    String value = (String) (sorter.get("Key"));
    assertEquals("Value", value);
  }

  public void testTwoNames() throws Exception {
    sorter.add("Key1", "Value1");
    sorter.add("Key2", "Value2");
    assertEquals("Value1", (String) sorter.get("Key1"));
    assertEquals("Value2", (String) sorter.get("Key2"));
  }

  public void testNoNames() throws Exception {
    assertNull(sorter.get("NoSuchKey"));
  }

  public void testNoSuchKey() throws Exception {
    sorter.add("one", "");
    sorter.add("two", "");
    sorter.add("three", "");
    sorter.add("four", "");
    sorter.add("five", "");
    sorter.add("six", "");
    assertNull(sorter.get("nothing"));
    assertNull(sorter.get("onex"));
    assertNull(sorter.get("twox"));
    assertNull(sorter.get("tw"));
    assertNull(sorter.get("five "));
  }

  public void testDuplicateKey() throws Exception {
    sorter.add("one", "1");
    sorter.add("two", "2");
    sorter.add("four", "4");

    sorter.add("one", "i");
    sorter.add("two", "ii");
    sorter.add("four", "iv");

    assertEquals("i", sorter.get("one"));
    assertEquals("ii", sorter.get("two"));
    assertEquals("iv", sorter.get("four"));
  }

  public void testManyKeys() throws Exception {
    sorter.add("one", "1");
    sorter.add("two", "2");
    sorter.add("three", "3");
    sorter.add("four", "4");
    sorter.add("five", "5");
    sorter.add("six", "6");
    sorter.add("seven", "7");

    assertEquals("1", sorter.get("one"));
    assertEquals("2", sorter.get("two"));
    assertEquals("3", sorter.get("three"));
    assertEquals("4", sorter.get("four"));
    assertEquals("5", sorter.get("five"));
    assertEquals("6", sorter.get("six"));
    assertEquals("7", sorter.get("seven"));
  }
}

